<?php

/**
 * Klasse Pstn_hw (PSTN Hardware)
 * Zeigt die Hardware configuration von ISDN (Die Kartennamen)
 * um die Einstellungen zu ändern
 */
class PstnHardware {

    public function clock($database, $table) {
        $query_new = $database->update("UPDATE $table SET clock=0");
        if (isset($_POST['sync_li0']) && preg_match("/$table-/", $_POST['sync_li0'])) {
            $clock = preg_replace("/$table-/", '', $_POST['sync_li0']);
            $database->update("UPDATE $table SET clock=1 WHERE port='" . $clock . "'");
        }
        if (isset($_POST['sync_li1'])) {
            $clock = preg_replace("/$table-/", '', $_POST['sync_li1']);
            $database->update("UPDATE $table SET clock=1 WHERE port='" . $clock . "'");
        }
        if ($_POST['sync_li0'] == 'crystal')
            $database->set("sync_port_li0", '1');
        else
            $database->set("sync_port_li0", '0');
        if ($_POST['sync_li0'] == 'auto')
            $database->set("sync_port_auto0", '1');
        else
            $database->set("sync_port_auto0", '0');
        if ($_POST['sync_li1'] == 'crystal')
            $database->set("sync_port_li1", '1');
        else
            $database->set("sync_port_li1", '0');
        if ($_POST['sync_li1'] == 'auto')
            $database->set("sync_port_auto1", '1');
        else
            $database->set("sync_port_auto1", '0');
    }

    /*
     * Clock - Synchonisation port
     */

    function getClock($li, $type, $database) {
        $res.="<span id='sync_port_li" . $li . "'><div class='col-sm-3'>&nbsp;&nbsp;" . HARDWARE_SYNC_PORT_DIS . ":</div><div class='col-sm-2'><select class='form-control' name='sync_li" . $li . "' onmouseover=\"Tip('" . ISDNHW_MASTER . "')\" onmouseout='UnTip()'>";

        //ISDN Auto
        if ($type != 'bf1t1e1' && $type != 'bf2t1e1' && $type != 'bf4t1e1' && $type != 'bf2E1' && $type != 'bf1E1' ) {
            ($database->get('sync_port_auto' . $li) == 1) ? $selected = "selected" : $selected = "";
            $res.="<option value='auto' $selected>Auto</option>";
        }

        //Crystal - Gilt für alle
        if ($type != 'bf2E1' && $type != 'bf1E1' ) {
            ($database->get('sync_port_li' . $li) == 1) ? $selected = "selected" : $selected = "";
            $res.="<option value='crystal' $selected>Crystal</option>";
        }

        //ISDN lif
        $query = $database->select("select port, clock from isdn where lif='" . $li . "' and type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1' and port_type!='FXS'");
        while ($entry = $database->fetch_array($query)) {
            ($entry['clock'] == 1) ? $selected = "selected" : $selected = "";
            $res.="<option value='isdn-" . $entry['port'] . "' $selected>" . $entry['port'] . "</option>";
        }

        //CAS lif
        $query = $database->select("select port, clock from cas where lif='" . $li . "'");

        while ($entry = $database->fetch_array($query)) {
            ($entry['clock'] == 1) ? $selected = "selected" : $selected = "";
            $res.="<option value='cas-" . $entry['port'] . "' $selected>" . $entry['port'] . "</option>";
        }

        $res.="</select></div></span>";

        return $res;
    }

    /*
     * Graphical representation
     */

    function graphic($database) {
        $form_elements = "<script>
			$(function() {
				\$( \"#accordion\" ).accordion({ collapsible: true, autoHeight: true, active: false });
			});
			</script>
			<div id='accordion' style='width:510px; margin-left:auto; margin-right:auto;'>
				<h3><a href='#'>" . HARDWARE_GRAPHIC_DIS . "</a></h3>
				<div><div >
					<div id='port1' style='z-index:3; position:absolute; width:95px; font-size:1.2em; margin-top:163px; margin-left:5px;'></div>
					<div id='port2' style='z-index:4; position:absolute; width:95px; font-size:1.2em; margin-top:163px; margin-left:111px;'></div>
					<div id='port3' style='z-index:5; position:absolute; width:95px; font-size:1.2em; margin-top:163px; margin-left:213px;'></div>
					<div id='port4' style='z-index:6; position:absolute; width:95px; font-size:1.2em; margin-top:163px; margin-left:315px;'></div>
					<div id='bild1' style='z-index:3; position:absolute; margin-top:93px; margin-left:5px;'></div>
					<div id='bild2' style='z-index:4; position:absolute; margin-top:93px; margin-left:110px;'></div>
					<div id='bild3' style='z-index:5; position:absolute; margin-top:93px; margin-left:211px;'></div>
					<div id='bild4' style='z-index:6; position:absolute; margin-top:93px; margin-left:312px;'></div>
					</div>
					<div style='height:205px'><img src='./includes/images/Zeichnung.png' title='Image Ports'></div>
				</div>
			</div>";

        $portswitch = $database->get("portswitch");
        $query = $database->select('SELECT type  FROM gsm WHERE lif="1"');
        $lif1 = sqlite_fetch_single($query);

        //Portswitch oder GSM
        if ($portswitch == 1 || $lif1 == "bf2GSM" || $lif1 == "bf1GSM") {
            $q = $database->select("SELECT port, port_type FROM isdn WHERE lif='0' and type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1' union SELECT port, port_type FROM analog WHERE lif='0'  union SELECT port, port_type FROM gsm WHERE lif='0'  union SELECT port, port_type FROM cas WHERE lif='0'  order by port_type, port");
            $i = 1;
            while ($ent = $database->fetch_array($q)) {
                $form_elements.="<script>
					$(document).ready(function() {
						document.getElementById('bild" . $i . "').innerHTML='<img src=\"./includes/images/Zeichnung-2.png\" title=\"Image Ports\">';
						document.getElementById('port" . $i . "').innerHTML='<div class=\"text-center\">" . $ent['port_type'] . $ent['port'] . "</div>';
					});
					</script>";
                $i++;
            }

            //Besonderer Fall, wenn das LI1 GSM ist, wird Portswitch per default aktiviert, die GSM Portsvon LI1 müssen aber extra angezeigt werden.
            if ($lif1 == "bf2GSM" || $lif1 == "bf1GSM") {
                $q = $database->select("SELECT port, port_type FROM gsm WHERE lif='1' order by port_type, port");
                $i = 3;
                while ($ent = $database->fetch_array($q)) {
                    if ($ent['port_type']=='hdlc') $ent['port_type']='ccs';
                    $form_elements.="<script>
						$(document).ready(function() {
							if ($('#port" . $i . "').html()==''){
								document.getElementById('bild" . $i . "').innerHTML='<img src=\"./includes/images/Zeichnung-2.png\" title=\"Image Ports\">';
								document.getElementById('port" . $i . "').innerHTML='<div class=\"text-center\">" . $ent['port_type'] . $ent['port'] . "</div>';
							}else{
								document.getElementById('port" . $i . "').innerHTML+='<div class=\"text-center\">" . $ent['port_type'] . $ent['port'] . "</div>';
							}
						});
						</script>";
                    $i++;
                }
            }
        } else {
            //Kontrollvariable für 2S02FXS Lif
            $isdn=false;
            $analog=false;
            $q = $database->select("SELECT lif, type, port, port_type, 'isdn' as table_name FROM isdn WHERE type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1' union SELECT lif, type, port, port_type, 'analog' as table_name FROM analog union SELECT lif, type, port, port_type, 'gsm' as table_name FROM gsm union SELECT lif, type, port, port_type, 'cas' as table_name FROM cas order by lif, port ;");

            $i = 1;
            $j = 1;
            $setj = false;
            while ($ent0 = $database->fetch_array($q)) {
                if ($ent0['port_type']=='hdlc') $ent0['port_type']='ccs';
                if ($ent0['lif'] == 0) {
                    $name['port1'] = 'port1';
                    $name['port2'] = 'port2';
                    $name['bild1'] = 'bild1';
                    $name['bild2'] = 'bild2';
                } elseif ($ent0['lif'] == 1) {
                    $name['port1'] = 'port3';
                    $name['port2'] = 'port4';
                    $name['bild1'] = 'bild3';
                    $name['bild2'] = 'bild4';
                }
                //Beim ersten Port von Li1 soll $j zurückgesetzt werden
                if (!$setj && $ent0['lif'] == 1) {
                    $setj = true;
                    $j = 1;
                    $i = 3;
                }

                //Line interface mit mehr als 2 ports
                if ($j > 3) {
                    $form_elements.="<script>
					$(document).ready(function() {
						show_line" . $ent0['lif'] . "=false;
						document.getElementById('" . $name['bild1'] . "').innerHTML='<img src=\"./includes/images/Zeichnung-1.png\" title=\"Image Ports\">';
						document.getElementById('" . $name['bild2'] . "').innerHTML='<img src=\"./includes/images/Zeichnung-1.png\" title=\"Image Ports\">';
					});
					</script>";
                }
                //2SO-2 FXS Modul
                if ($ent0['type'] == "bf2S02FXS") {
                    $form_elements.="<script>
					$(document).ready(function() {
						if (typeof(show_line" . $ent0['lif'] . ")=='undefined') document.getElementById('bild" . $i . "').innerHTML='<img src=\"./includes/images/Zeichnung-2.png\" title=\"Image Ports\">';
					});		
                                        </script>";
                    //Analog Ports rechts platzieren
                    if ($ent0['table_name'] == "analog") {
                        if ($analog==true) $i++;
                        $form_elements.="<script>
					$(document).ready(function() {
							$('#port" . $i . "').append('<div style=\'float:right;\'>" . $ent0['port_type'] . $ent0['port'] . "</div>');
                                        });
					</script>";
                        $analog=true;
                        $isdn=false;
                        //ISDN Ports links platzieren
                    } else if ($ent0['table_name'] == "isdn") {
                        //Wenn 2 ISDN Ports hintereinander in dem DB ergebnis kommen,
                        //soll der 2. Port zu dem nächsten Slot zugeordnet werden
                        if ($isdn==true) $i++;
                        $form_elements.="<script>
					$(document).ready(function() {
						$('#port" . $i . "').append('<div style=\'float:left;\'>" . $ent0['port_type'] . $ent0['port'] . "</div>');
                                        });
					</script>";
                        if ($isdn==true) $i=$i-2;
                        $analog=false;
                        $isdn=true;
                    }
                    if ($j % 2 == 0)
                        $i++;
                    if ($i == 3 && $ent0['lif'] == 0)
                        $i = 1;
                    else if ($i == 5 && $ent0['lif'] == 1)
                        $i = 3;
                    $j++;
                    //8FXS Modul
                }elseif ($ent0['type'] == "bf8FXS") {
                    $form_elements.="<script>
					$(document).ready(function() {
						document.getElementById('" . $name['bild1'] . "').innerHTML='<img src=\"./includes/images/Zeichnung-2.png\" title=\"Image Ports\">';
                                                document.getElementById('" . $name['bild2'] . "').innerHTML='<img src=\"./includes/images/Zeichnung-2.png\" title=\"Image Ports\">';
						document.getElementById('" . $name['port1'] . "').innerHTML='<div style=\'float:left;\'>bf8FXS</div>';
                                                document.getElementById('" . $name['port2'] . "').innerHTML='<div style=\'float:left;\'>bf8FXS</div>'});
					</script>";
                    //Alle übrigen Module
                } else {

                    $form_elements.="<script>
					$(document).ready(function() {
						if (typeof(show_line" . $ent0['lif'] . ")=='undefined') document.getElementById('bild" . $i . "').innerHTML='<img src=\"./includes/images/Zeichnung-2.png\" title=\"Image Ports\">';
						if (document.getElementById('port" . $i . "').innerHTML!='')
							document.getElementById('port" . $i . "').innerHTML+='<div style=\'float:right;\'>" . $ent0['port_type'] . $ent0['port'] . "</div>';
						else";
                    if ($database->get_count_port($ent0['lif']) <= 2)
                        $form_elements.=" document.getElementById('port" . $i . "').innerHTML+='<div class=\"text-center\">" . $ent0['port_type'] . $ent0['port'] . "</div>';";
                    else
                        $form_elements.=" document.getElementById('port" . $i . "').innerHTML+='<div style=\'float:left;\'>" . $ent0['port_type'] . $ent0['port'] . "</div>';";
                    $form_elements.="});
					</script>";
                    if ($database->get_count_port($ent0['lif']) <= 2)
                        $j++;
                    if ($j % 2 == 0)
                        $i++;
                    if ($database->get_count_port($ent0['lif']) >= 2)
                        $j++;
                }
            }
        }

        return $form_elements;
    }

    /*
     * Funktion display erzeugt den Inhalt von der HTML-Seite
     */

    public function display() {


        $m = $_GET['m'];
        $q = $_GET['q'];
        $start = $_GET['start'];
        $name="HARDWARE_TITLE_DIS";
        include('./includes/header.php');

        //Änderungen speichern
        if (isset($_POST['id_upd']) || isset($_POST['pcm_ip'])) {
            $database = new beroAri();

            if (isset($_POST['pcm_server']))
                $database->set('pcm_server', '1');
            else
                $database->set('pcm_server', '0');
            if ($_POST['master_li0'] == "0" && $_POST['master_li1'] == "0")
                $database->set('pcm_server', sqlite_escape_string($_POST['pcm_ip']));
            elseif ($_POST['master_li0'] == "0" && !isset($_POST['master_li1']))
                $database->set('pcm_server', sqlite_escape_string($_POST['pcm_ip']));
            elseif ($_POST['master_li1'] == "0" && !isset($_POST['master_li0']))
                $database->set('pcm_server', sqlite_escape_string($_POST['pcm_ip']));
            elseif (!isset($_POST['master_li1']) && !isset($_POST['master_li0']))
                $database->set('pcm_server', sqlite_escape_string($_POST['pcm_ip']));

            $database->set('pcm_server_port', sqlite_escape_string($_POST['pcm_server_port']));
            //Country Settings
            if (isset($_POST['country'])) {
                $database->set('country', sqlite_escape_string($_POST['country']));
            } else {
                $database->set('country', '');
            }
            if (isset($_POST['ohs'])) {
                $ohs=  explode("|", $_POST['ohs']);
                $ohs1=explode("=",$ohs[0]);
                $ohs2=explode("=",$ohs[1]);
                $database->set('ohs', sqlite_escape_string($ohs1[1]));
                $database->set('ohs2', sqlite_escape_string($ohs2[1]));
            } else {
                $database->set('ohs', '0');
                $database->set('ohs2', '0');
            }
            if (isset($_POST['rt'])) {
                $rt=  explode("|", $_POST['rt']);
                $rt1=explode("=",$rt[0]);
                $rt2=explode("=",$rt[1]);
                $database->set('rt', sqlite_escape_string($rt1[1]));
                $database->set('rt2', sqlite_escape_string($rt2[1]));
            } else {
                $database->set('rt', '0');
                $database->set('rt2', '0');
            }
            (isset($_POST['rz'])) ? $database->set('rz', sqlite_escape_string($_POST['rz'])) : $database->set('rz', '0');
            (isset($_POST['dcv'])) ? $database->set('dcv', sqlite_escape_string($_POST['dcv'])) : $database->set('dcv', '0x0');
            (isset($_POST['mini'])) ? $database->set('mini', sqlite_escape_string($_POST['mini'])) : $database->set('mini', '0x0');
            (isset($_POST['acim'])) ? $database->set('acim', sqlite_escape_string($_POST['acim'])) : $database->set('acim', '0x0');
            (isset($_POST['ilim'])) ? $database->set('ilim', sqlite_escape_string($_POST['ilim'])) : $database->set('ilim', '0');
                        
            //END Country settings
            if (isset($_POST['boostringer'])) {
                $database->set('boostringer', sqlite_escape_string($_POST['boostringer']));
            } else {
                $database->set('boostringer', '0');
            }
            //ISDN clock
            $this->clock($database, "isdn");

            //CAS clock
            $this->clock($database, "cas");


            $revision = exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
            if (isset($_POST['portswitch']) && $revision != "1.80" && $revision != "1.8") {
                $q = $database->select("SELECT value from key_val WHERE key='portswitch'");
                if (sqlite_fetch_single($q) != "") {
                    $database->update("UPDATE key_val set value=1 WHERE key='portswitch'");
                } else {
                    $database->insert_("INSERT into key_val (key,value) VALUES('portswitch',1)");
                }
            } elseif (!isset($_POST['portswitch']) && $revision != "1.80" && $revision != "1.8") {
                $q = $database->select("SELECT value from key_val WHERE key='portswitch'");
                if (sqlite_fetch_single($q) != "") {
                    $database->update("UPDATE key_val set value=0 WHERE key='portswitch'");
                } else {
                    $database->insert_("INSERT into key_val (key,value) VALUES('portswitch',0)");
                }
            }

            $id = $_POST['id_upd'];
            $type_array = $_POST['type'];
            $update_cas_channels = false;
            for ($i = 0; $i < count($id); $i++) {
                $id_upd = $id[$i];
                $type = $type_array[$i];
                //ISDN spezifieche Einstellungen speichern
                if ($type == "isdn") {
                    $mode = "mode" . $id_upd;
                    $mode_id = $_POST[$mode];
                    $ptp = "ptp" . $id_upd;
                    $ptp_id = $_POST[$ptp];
                    $lt = "lt" . $id_upd;
                    $lt_id = $_POST[$lt];
                    $crystal_clock = "crystal_clock" . $id_upd;
                    $crystal_clock_id = $_POST[$crystal_clock];
                    $permanentl1 = "permanentl1" . $id_upd;
                    $permanentl1_id = $_POST[$permanentl1];
                    $crc = "crc" . $id_upd;
                    $crc_id = $_POST[$crc];
                    if ($ptp_id == "") {
                        $ptp_id = "1";
                    }
                    if ($permanentl1_id == "") {
                        $permanentl1_id = "0";
                    }
                    if ($lt_id == "") {
                        $lt_id = "0";
                    }
                    if ($crc_id == "") {
                        $crc_id = "0";
                    }
                    $query_upd = $database->update("UPDATE isdn SET ntteHW='" . sqlite_escape_string($mode_id) . "', ntteSW='" . sqlite_escape_string($mode_id) . "', ptp='" . sqlite_escape_string($ptp_id) . "', lt='" . sqlite_escape_string($lt_id) . "', crc='" . sqlite_escape_string($crc_id) . "', crystal_clock='" . sqlite_escape_string($crystal_clock_id) . "', permanentl1='" . sqlite_escape_string($permanentl1_id) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");
                }
                //CAS speichern
                if ($type == "cas") {
                    $termination = $_POST["casmode" . $id_upd];
                    if ($termination == "")
                        $termination = "te";
		    $coding=$_POST["coding" . $id_upd];
                    $query_upd = $database->update("UPDATE cas SET termination='" . sqlite_escape_string($termination) . "', coding='".sqlite_escape_string($coding)."' WHERE port='" . sqlite_escape_string($id_upd) . "'");
                }
                //CAS Hardware modus Änderungen
                if ($type == "cashw") {
                    $t1e1 = $_POST["t1e1" . $id_upd];
                    if ($t1e1 == 1) {
                        $protocol = "t1";
                    } else {
                        $protocol = "e1";
                    }
                    $interface_type = $_POST["interface_type" . $id_upd];

                    $query = $database->select("select port_type from cas where port='" . sqlite_escape_string($id_upd) . "'");
                    $old_interface_type = sqlite_fetch_single($query);
                    if ($old_interface_type != $interface_type)
                        $update_isdn = true;
                    $query = $database->select("select protocol from cas where port='" . sqlite_escape_string($id_upd) . "'");
                    $old_protocol = sqlite_fetch_single($query);
                    if ($old_protocol != $protocol)
                        $update_cas_channels = true;
                    $query_upd = $database->update("UPDATE cas SET protocol='" . sqlite_escape_string($protocol) . "', port_type='" . sqlite_escape_string($interface_type) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");
                    $ba->set('set_hw', 1);
                }
            }

            //Wenn das cas protokoll (t1 oder e1) sich geändert hat, werden alle 
            //channels gelöscht und neu angeordnet
            if ($update_cas_channels == true || $update_isdn == true) {
                //Keine hdlc ports berücksichtigen
                $isdn_lif = $database->select("select distinct lif from isdn where ccs=0");
                $lif = sqlite_fetch_single($isdn_lif);
                if ($lif == 0)
                    $before = true;
                elseif ($lif == 1)
                    $after = true;
                //Keine hdlc ports berücksichtigen
                $query_isdn = $database->select("select * from isdn where ccs=0");

                $query_del = $database->delete("delete from isdn");
                $query_del = $database->delete("delete from cas_channels");

                //Gespeicherte ISDN Ports in lif0 zurücksetzen
                if ($before) {
                    while ($entry = $database->fetch_array($query_isdn)) {
                        $database->insert_('INSERT INTO isdn (type, lif, master, port_type, clock) ' .
                                'VALUES (\'' . $entry['type'] . '\',\'' . $entry['lif'] . '\',\'' . $entry['master'] . '\',\'' . $entry['port_type'] . '\',\'' . $value['clock'] . '\');');
                    }
                }
                $query = $database->select("select port, type, port_type, protocol, lif from cas order by port");
                while ($entry = $database->fetch_array($query)) {
                    //CAS channels speichern
                    if ($entry['protocol'] == 't1' && $entry['port_type'] == 'cas')
                        for ($j = 0; $j < 24; $j++) {
                            $database->insert_("INSERT INTO cas_channels (port) VALUES('" . $entry['port'] . "');");
                        }
                    if ($entry['protocol'] == 'e1' && $entry['port_type'] == 'cas') {
                        for ($j = 0; $j < 31; $j++) {
                            $database->insert_("INSERT INTO cas_channels (port) VALUES('" . $entry['port'] . "');");
                            if ($j == 15)
                                $channel = $database->rowid();
                        }
                        //Sigchan weglassen
                        $database->delete("delete from cas_channels where channel='" . $channel . "';");
                    }
                    //Channels (HDLC) in der ISDN Tabelle speichern
                    if ($entry['port_type'] == 'hdlc')
                        $database->insert_('INSERT INTO isdn (type, lif, master, port_type) ' .
                                'VALUES (\'' . $entry['type'] . '\',\'' . $entry['lif'] . '\',\'0\',\'PRI\');');
                }


                //Gespeicherte ISDN Ports in lif1 zurücksetzen
                if ($after) {
                    while ($entry = $database->fetch_array($query_isdn)) {
                        $database->insert_('INSERT INTO isdn (type, lif, master, port_type, clock) ' .
                                'VALUES (\'' . $entry['type'] . '\',\'' . $entry['lif'] . '\',\'' . $entry['master'] . '\',\'' . $entry['port_type'] . '\',\'' . $entry['clock'] . '\');');
                    }
                }
            }
	
	    $masterdb='pcm';
            //Master-Slave option speichern
            for ($i = 0; $i < 2; $i++) {
                //FXO special setting
                if (($_POST['card_type0'] == "bf4FXO" || $_POST['card_type0'] == "bf2FXO") && ($_POST['card_type1'] == "bf4FXO" || $_POST['card_type1'] == "bf2FXO")) {
                    $database->update("UPDATE isdn SET master='1' where lif='0' ");
                    $database->update("UPDATE isdn SET master='0' where lif='1' ");
                    continue;
                }
                if ($_POST['master_li' . $i] == "1" || !isset($_POST['master_li' . $i])) {
                    $database->update("UPDATE isdn SET master='1' where lif='" . $i . "' ");
                    $database->update("UPDATE analog SET master='1' where lif='" . $i . "' ");
                    $database->update("UPDATE cas SET master='1' where lif='" . $i . "' ");
                    $database->update("UPDATE gsm SET master='1' where lif='" . $i . "' ");
		    if (strstr($masterdb,'pcm')) 
			$masterdb=$i;
		    else
		    	$masterdb="all";
                } else {
                    $database->update("UPDATE isdn SET master='0' where lif='" . $i . "' ");
                    $database->update("UPDATE analog SET master='0' where lif='" . $i . "' ");
                    $database->update("UPDATE cas SET master='0' where lif='" . $i . "' ");
                    $database->update("UPDATE gsm SET master='0' where lif='" . $i . "' ");
                }
            }
	    $database->set('master', $masterdb);

            $ret.=Helper::activate(3, true, $_GET['m'], ACTIVATE);
        }



        $pstn_hw_table = $this->dynamic_table();
        // build page content
        $ret.="<script>
                function enablepl1(port){
                    if ($('#mode'+port+' option:selected').val()=='te')
                        $('#permanentl1'+port).attr('disabled', false);
                    else
                         $('#permanentl1'+port).attr('disabled', true);
                }
                
		function pcm_ip_check(){
			try{
				if (document.getElementsByName('master_li0')[0].selectedIndex==1 && document.getElementsByName('master_li1')[0].selectedIndex==1 && document.getElementsByName('pcm_ip')[0].value==''){
					alert('" . HARDWARE_PCM_MASTER_IP_WARNING_DIS . "');
					return false;
				}else if(document.getElementsByName('master_li0')[0].selectedIndex==1 && document.getElementsByName('master_li1')[0].selectedIndex==1 && document.getElementsByName('pcm_ip')[0].value.length>=255){
					alert('" . HARDWARE_PCM_MASTER_IP_WARNING1_DIS . "');
					return false;
				}else{
					return true;
				}
			}catch(e){
				return true;
			}
		}</script>";
        $ret .= "<form name='isdn_hw' id='pstn_hw' class='form-horizontal' action='' method='POST' onsubmit='return pcm_ip_check();'>
			<input type='hidden' name='m' value='" . $m . "'>
			<br/>
			" . $pstn_hw_table . "
			<br/>
			</form>";

        //Rückgabe: Inhalt der HTML-Seite
        return $ret;
    }

    public function mode($ba, $act_mode, $id) {
        if ($act_mode == 'te') {
            $mode.="<option value='nt'>nt</option>";
            $mode.="<option value='te' selected>te</option>";
        } else {
            $mode.="<option value='nt' selected>nt</option>";
            $mode.="<option value='te'>te</option>";
        }
        return $mode;
    }

    public function hw_mode($ba, $act_mode) {
        if ($act_mode == 'hdlc') {
            $mode.="<option value='cas'>cas</option>";
            $mode.="<option value='hdlc' selected>ccs</option>";
        } else {
            $mode.="<option value='cas' selected>cas</option>";
            $mode.="<option value='hdlc'>ccs</option>";
        }
        return $mode;
    }
    
    public function coding($codingval,$port) {
	    ${$codingval}='selected';
	    $coding="<select class='form-control' name='coding" . $port . "'>";
	    $coding.="<option value='B8ZS' ".$B8ZS.">B8ZS</option>";
            $coding.="<option value='AMI' ".$AMI.">AMI</option>";
	    $coding.="</selected>";
	    return $coding;
    }

    public function crystal_clock($ba, $crystal_clock, $id) {
        if ($crystal_clock == '1') {
            $mode.="<option value='1' selected>Internal Crystal</option>";
            $mode.="<option value='0'>External</option>";
        } else {
            $mode.="<option value='1'>Internal Crystal</option>";
            $mode.="<option value='0' selected>External</option>";
        }
        return $mode;
    }

    /*
     * Funktion dynamic_table
     */

    public function dynamic_table() {
        //Ein neues Datenbankobjekt von der Datenbank.
        $database = new beroAri();
        require_once("./includes/lang.php");

        $country = array("FCC", "TBR21", "1TR110_DE", "ARGENTINA", "AUSTRALIA", "AUSTRIA", "BAHRAIN",
            "BELGIUM", "BRAZIL", "BULGARIA", "CANADA", "CHILE", "CHINA", "COLOMBIA", "CROATIA",
            "CYPRUS", "CZECH", "DENMARK", "ECUADOR", "EGYPT", "ELSALVADOR", "FINLAND", "FRANCE",
            "GERMANY", "GREECE", "GUAM", "HONGKONG", "HUNGARY", "ICELAND", "INDIA", "INDONESIA",
            "IRELAND", "ISRAEL", "ITALY", "JAPAN", "JORDAN", "KAZAKHSTAN", "KUWAIT", "LATVIA",
            "LEBANON", "LUXEMBOURG", "MACAO", "MALAYSIA", "MALTA", "MEXICO", "MOROCCO", "NETHERLANDS",
            "NEWZEALAND", "NIGERIA", "NORWAY", "OMAN", "PAKISTAN", "PERU", "PHILIPPINES", "POLAND",
            "PORTUGAL", "ROMANIA", "RUSSIA", "SAUDIARABIA", "SINGAPORE", "SLOVAKIA", "SLOVENIA",
            "SOUTHAFRICA", "SOUTHKOREA", "SPAIN", "SWEDEN", "SWITZERLAND", "SYRIA", "TAIWAN", "THAILAND",
            "UAE", "UK", "USA", "YEMEN","USER");
        $q = $database->select("SELECT distinct lif, type FROM cas order by lif");

        //Änderung des Interface Types und Protocols wenn CAS gesteckt ist und keine keine Einstellungen vorgenommen wurden
        if (check() == 1 && sqlite_num_rows($q) != 0 && $database->get("set_hw") == "") {
            //CAS
            $form_elements.="<h3><div class='text-center'>" . HARDWARE_INTERFACE_TYPE_MESSAGE_DIS . ""
                    . "<input type='hidden' name='set_hw' value='true' /></div></h3>";
            while ($ent = $database->fetch_array($q)) {
                $query = $database->select("select * from cas where lif='" . $ent['lif'] . "'");
                $form_elements.="<br /><br /><table class='table table-striped table-bordered' style='width:90% !important; margin:auto;'>
					<tr><th colspan='7'><div class='text-center'>" . HARDWARE_CARD_TYPE_DIS . ":&nbsp;" . $ent['type'] .
                        "&nbsp;&nbsp;" . HARDWARE_LINE_INTERFACE_DIS . ":&nbsp;" . $ent['lif'] . "&nbsp;&nbsp;</div></th></tr>";
                while ($entry = $database->fetch_array($query)) {
                    $form_elements.="<tr>
				<td><b>" . HARDWARE_PORT_DIS . ":</b>&nbsp;" . $entry['port'] . "&nbsp;</td>
				<td colspan='4'><div class='col-sm-5'><b>" . HARDWARE_INTERFACE_TYPE_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='interface_type" . $entry['port'] . "'>" . $this->hw_mode($database, $entry['port_type']) .
                            "</select></div><input type=hidden name=id_upd[] value=" . $entry['port'] . ">
				<input type=hidden name=type[] value='cashw'></td>";

                    if ($entry['protocol'] == "t1") {
                        $form_elements.="<td><div class='col-sm-3'><b>" . HARDWARE_PROTOCOL_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='t1e1" . $entry['port'] . "' onmouseover=\"Tip('" . "T1 or E1" . "')\" onmouseout='UnTip()'>
						<option value=1 selected>T1</option>
						<option value=0>E1</option>
						</select>
						</div>
						<input type=hidden name=id_upd[] value=" . $entry['port'] . ">
						<input type=hidden name=type[] value='cas'></td>";
                    } else {
                        $form_elements.="<td><div class='col-sm-3'><b>" . HARDWARE_PROTOCOL_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='t1e1" . $entry['port'] . "' onmouseover=\"Tip('" . "T1 or E1" . "')\" onmouseout='UnTip()'>
						<option value=1>T1</option>
						<option value=0 selected>E1</option>
						</select>
						</div>
						<input type=hidden name=id_upd[] value=" . $entry['port'] . ">
						<input type=hidden name=type[] value='cas'></td>";
                    }
                }
                $form_elements.="</table>";
            }

            $form_elements.="<div class='text-center'><input type='submit' class='btn btn-default' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . ISDNHW_SAVE . "')\" onmouseout='UnTip()'></div>";
        } else {
            //Grafische Darstellung der Portsbelegung in Form eines Bilds
            $form_elements.=$this->graphic($database);

            //Zeigen des master-slave Drop-downs wenn die beiden Lineinterfaces belegt sind
            $q = $database->select("select type, lif, master from isdn WHERE type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1' group by type,lif, master union select type, lif, master from analog group by type,lif, master union select type, lif, master from gsm group by type,lif, master union select type, lif, master from cas group by type,lif, master order by lif;");
            while ($ent = $database->fetch_array($q)) {
                $li[$ent['lif']] = $ent['lif'];
                $type[$ent['lif']] = $ent['type'];
            }
            if (isset($li[0]) && isset($li[1])) {
                $show_master = 1;
            }

            $q = $database->select("select type, lif, master from isdn where type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1' group by type,lif, master union select type, lif, master from analog group by type,lif, master union select type, lif, master from gsm group by type,lif, master union select type, lif, master from cas group by type,lif, master order by lif;");
            while ($ent = $database->fetch_array($q)) {
                if ($ent['type'] != "bf1E1" && $ent['type'] != "bf2E1") {
                    $form_elements.="<br/><br/><table class='table table-striped table-bordered' style='width:90% !important; margin:auto;'>
					<tr><th colspan='6'><div class='text-center form-group'><div class='col-sm-5'><input type=hidden name='card_type" . $ent['lif'] . "' value='" . $ent['type'] ."'>" . HARDWARE_CARD_TYPE_DIS . ":&nbsp;" . $ent['type'] .
                            "&nbsp;&nbsp;" . HARDWARE_LINE_INTERFACE_DIS . ":&nbsp;" . $ent['lif'] . "&nbsp;&nbsp;";
                } else {
                    $form_elements.="<br /><br /><table class='table table-striped table-bordered' style='width:90% !important; margin:auto;'>
					<tr><th colspan='7'><div class=\"text-center form-group\"><div class='col-sm-5'>" . HARDWARE_CARD_TYPE_DIS . ":&nbsp;" . $ent['type'] .
                            "&nbsp;&nbsp;" . HARDWARE_LINE_INTERFACE_DIS . ":&nbsp;" . $ent['lif'] . "&nbsp;&nbsp;";
                }
                $form_elements.=HARDWARE_MASTER_DIS . ":&nbsp;</div>";
                ($ent['type'] == "bf2GSM" || $ent['type'] == "bf1GSM" || $ent['type'] == "bf4FXO" || $ent['type'] == "bf2FXO") ? $dis = "disabled" : $dis = "";
                if ($ent['master'] == 1)
                    $form_elements.="<div class='col-sm-2'>"
			. "<select class='form-control' name='master_li" . $ent['lif'] . "' onchange='check_master()' onmouseover=\"Tip('" . HARDWARE_MASTER . "')\" onmouseout='UnTip()' $dis>
												<option value='1' selected>" . HARDWARE_OPTION_MASTER_DIS . "</option>
												<option value='0'>" . HARDWARE_OPTION_SLAVE_DIS . "</option>
												</select>
												</div>";
                elseif ($ent['master'] == 0)
                    $form_elements.="<div class='col-sm-2'>"
			. "<select class='form-control' name='master_li" . $ent['lif'] . "' onchange='check_master()' onmouseover=\"Tip('" . HARDWARE_MASTER . "')\" onmouseout='UnTip()' $dis>
								<option value='1'>" . HARDWARE_OPTION_MASTER_DIS . "</option>
								<option value='0' selected>" . HARDWARE_OPTION_SLAVE_DIS . "</option>
								</select>
								</div>";
                else
                    $form_elements.="<div class='col-sm-2'>"
			. "<select class='form-control' name='master_li" . $ent['lif'] . "' onchange='check_master()' onmouseover=\"Tip('" . HARDWARE_MASTER . "')\" onmouseout='UnTip()' $dis>
								<option value='1' selected>" . HARDWARE_OPTION_MASTER_DIS . "</option>
								<option value='0'>" . HARDWARE_OPTION_SLAVE_DIS . "</option>
								</select>
								</div>";

                //Clock - Synchonisation port
                if (!in_array($ent['type'], array("bf4FXS", "bf8FXS", "bf4FXO", "bf2FXO", "bf1FXS", "bf2GSM"))) {
                    $form_elements.=$this->getClock($ent['lif'], $ent['type'], $database);
                }
                $form_elements.="</div></th></tr>";
                //ISDN
                $query = $database->select("select * from isdn where lif='" . $ent['lif'] . "' and type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1'");
                while ($entry = $database->fetch_array($query)) {
                    if ($entry['type'] != "bf1E1" && $entry['type'] != "bf2E1") {
                        $form_elements.="<tr>
						<td><b>" . HARDWARE_PORT_DIS . ":</b>&nbsp;" . $entry['port'] . "&nbsp;</td>
						<td><b>" . HARDWARE_PORT_TYPE_DIS . ":</b>&nbsp;" . $entry['port_type'] . "</td>
						<td><div class='col-sm-3'><b>" . HARDWARE_TYPE_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='mode" . $entry['port'] . "' id='mode" . $entry['port'] . "' onmouseover=\"Tip('" . ISDNHW_MODE . "')\"
							onmouseout='UnTip()' onchange='enablepl1(\"" . $entry['port'] . "\");'>" . $this->mode($database, $entry['ntteHW'], $entry['port']) . "</select></div></td>";
                        if ($entry['ptp'] == 1) {
                            $form_elements.="<td><div class='col-sm-5'><b>" . HARDWARE_PROTOCOL_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='ptp" . $entry['port'] . "' onmouseover=\"Tip('" . ISDNHW_PTP . "')\" onmouseout='UnTip()'>
								<option value=1 selected>PTP</option>
								<option value=0>PMP</option>
								</select>
								</div>
								<input type=hidden name=id_upd[] value=" . $entry['port'] . ">
								<input type=hidden name=type[] value='isdn'></td>";
                        } else {
                            $form_elements.="<td><div class='col-sm-5'><b>" . HARDWARE_PROTOCOL_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='ptp" . $entry['port'] . "' onmouseover=\"Tip('" . ISDNHW_PTP . "')\" onmouseout='UnTip()'>
								<option value=1>PTP</option>
								<option value=0 selected>PMP</option>
								</select>
								</div>
								<input type=hidden name=id_upd[] value=" . $entry['port'] . ">
								<input type=hidden name=type[] value='isdn'></td>";
                        }
                        if ($entry['lt'] == 1) {
                            $form_elements.="<td><b>" . HARDWARE_TERMINATION_DIS . ":</b>&nbsp;<input type='checkbox' name='lt" . $entry['port'] . "' checked value='1' onmouseover=\"Tip('" . ISDNHW_LT . "')\" onmouseout='UnTip()'></td>";
                        } else {
                            $form_elements.="<td><b>" . HARDWARE_TERMINATION_DIS . ":</b>&nbsp;<input type='checkbox' name='lt" . $entry['port'] . "' value='1' onmouseover=\"Tip('" . ISDNHW_LT . "')\" onmouseout='UnTip()'></td>";
                        }
                        if ($entry['permanentl1'] == 1) {
                            $form_elements.="<td><b>" . HARDWARE_PERMANENTL1_DIS . ":</b>&nbsp;<input type='checkbox' name='permanentl1" . $entry['port'] . "' id='permanentl1" . $entry['port'] . "' checked value='1'><script>enablepl1(\"" . $entry['port'] . "\");</script></td>";
                        } else {
                            $form_elements.="<td><b>" . HARDWARE_PERMANENTL1_DIS . ":</b>&nbsp;<input type='checkbox' name='permanentl1" . $entry['port'] . "' id='permanentl1" . $entry['port'] . "' value='1'><script>enablepl1(\"" . $entry['port'] . "\");</script></td>";
                        }
                    } else {
                        $form_elements.="<tr>
						<td><b>" . HARDWARE_PORT_DIS . ":</b>&nbsp;" . $entry['port'] . "&nbsp;</td>
						<td><b>" . HARDWARE_PORT_TYPE_DIS . ":</b>&nbsp;" . $entry['port_type'] . "</td>
						<td><div class='col-sm-3'><b>" . HARDWARE_TYPE_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='mode" . $entry['port'] . "' id='mode" . $entry['port'] . "' onmouseover=\"Tip('" . ISDNHW_MODE . "')\"
						onmouseout='UnTip()' onchange='enablepl1(\"" . $entry['port'] . "\");'>" . $this->mode($database, $entry['ntteHW'], $entry['port']) . "</select></div></td>";
                        $form_elements.="<td><div class='col-sm-5'><b>" . HARDWARE_PROTOCOL_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='ptp" . $entry['port'] . "' onmouseover=\"Tip('" . ISDNHW_PTPE1 . "')\" onmouseout='UnTip()'>
						<option value=1 selected>PTP</option>
						</select>
						</div>
						<input type=hidden name=id_upd[] value=" . $entry['port'] . ">
						<input type=hidden name=type[] value='isdn'></td>";
                        if ($entry['crc'] == 1) {
                            $form_elements.="<td><b>" . HARDWARE_CRC_DIS . ":</b>&nbsp;<input type='checkbox' name='crc" . $entry['port'] . "' checked value='1'></td>";
                        } else {
                            $form_elements.="<td><b>" . HARDWARE_CRC_DIS . ":</b>&nbsp;<input type='checkbox' name='crc" . $entry['port'] . "' value='1'></td>";
                        }
                        $form_elements.="<td><b>" . HARDWARE_CLOCK_MODE_DIS . ":</b>&nbsp;<input type='hidden' name='crystal_clock" . $entry['port'] . "' value='0'/><select class='form-control' name='crystal_clock" . $entry['port'] . "' class='crystal_clock".$ent['lif']."'>" . $this->crystal_clock($database, $entry['crystal_clock'], $entry['port']) . "</select></td>";
                        if ($entry['permanentl1'] == 1) {
                            $form_elements.="<td><b>" . HARDWARE_PERMANENTL1_DIS . ":</b>&nbsp;<input type='checkbox' name='permanentl1" . $entry['port'] . "' id='permanentl1" . $entry['port'] . "' checked value='1'><script>enablepl1(\"" . $entry['port'] . "\");</script></td>";
                        } else {
                            $form_elements.="<td><b>" . HARDWARE_PERMANENTL1_DIS . ":</b>&nbsp;<input type='checkbox' name='permanentl1" . $entry['port'] . "' id='permanentl1" . $entry['port'] . "' value='1'><script>enablepl1(\"" . $entry['port'] . "\");</script></td>";
                        }
                    }
                }

                //ANALOG
                $query = $database->select("select * from analog where lif='" . $ent['lif'] . "'");
                while ($entry = $database->fetch_array($query)) {
                    $form_elements.="<tr>
				<td><b>" . HARDWARE_PORT_DIS . ":</b>&nbsp;" . $entry['port'] . "&nbsp;</td>
				<td colspan='5'><b>" . HARDWARE_PORT_TYPE_DIS . ":</b>&nbsp;" . $entry['port_type'] .
                            "<input type=hidden name=id_upd[] value=" . $entry['port'] . ">
				<input type=hidden name=type[] value='analog'></td>";
                }
                //GSM
                $query = $database->select("select * from gsm where lif='" . $ent['lif'] . "'");
                while ($entry = $database->fetch_array($query)) {
                    $form_elements.="<tr>
				<td><b>" . HARDWARE_PORT_DIS . ":</b>&nbsp;" . $entry['port'] . "&nbsp;</td>
				<td colspan='5'><b>" . HARDWARE_PORT_TYPE_DIS . ":</b>&nbsp;" . $entry['port_type'] .
                            "</td>";
                }
                //CAS
                $query = $database->select("select * from cas where lif='" . $ent['lif'] . "'");
                while ($entry = $database->fetch_array($query)) {
                    //HDCL in CCS für die Anzeige umbenennen
                    if ($entry['port_type']=='hdlc'){
			    $entry['port_type']='ccs';
			    $colspan=3;
		    }else{
			    $colspan=2;
		    }
                    $form_elements.="<tr onmouseover=\"Tip('" . HARDWARE_HWMODE_HINT . "')\" onmouseout='UnTip()'>
				<td><b>" . HARDWARE_PORT_DIS . ":</b>&nbsp;" . $entry['port'] . "&nbsp;</td>
				<td colspan='$colspan'><b>" . HARDWARE_INTERFACE_TYPE_DIS . ":</b>&nbsp;" . $entry['port_type'] . "</td>";
		    if ($entry['port_type']=='cas'){
			    $form_elements.="<td><div class='col-sm-5'><b>" . HARDWARE_CODING_DIS . ":</b></div><div class='col-sm-7'>".$this->coding($entry['coding'],$entry['port'])."</div></td>";
		    }
                    $form_elements.="<td><b>" . HARDWARE_PROTOCOL_DIS . ":</b>&nbsp;" . $entry['protocol'] . "
						</td>
                                         <td><div class='col-sm-3'><b>" . HARDWARE_TYPE_DIS . ":</b></div><div class='col-sm-7'><select class='form-control' name='casmode" . $entry['port'] . "' onmouseover=\"Tip('" . ISDNHW_MODE . "')\"
							onmouseout='UnTip()' ";
                    ($entry['port_type'] == 'cas') ? $form_elements.="disabled" : $form_elements.="";
                    $form_elements.=">" . $this->mode($database, $entry['termination'], $entry['port']) . "</select></div>"
                            . "                 <input type=hidden name=id_upd[] value=" . $entry['port'] . ">
                                                <input type=hidden name=type[] value='cas'></td>";
		    $form_elements.="</td>";
                }
                $form_elements.="</table>";
            }

            $revision = exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
            $q = $database->select("select type, lif from isdn where type!='bf2t1e1' and type!='bf1t1e1' and type!='bf4t1e1' group by type,lif union select type, lif from analog group by type,lif union select type, lif from cas group by type,lif order by lif;");
            while ($ent = $database->fetch_array($q)) {
                $li[$ent['lif']] = $ent['lif'];
                $type[$ent['lif']] = $ent['type'];
            }

            //Country
            if ($type[0] == "bf4FXO" || $type[1] == "bf4FXO" || $type[0] == "bf2FXO" || $type[1] == "bf2FXO" || $type[0] == "bf4FXS" || $type[1] == "bf4FXS" || $type[0] == "bf8FXS" || $type[1] == "bf8FXS" || $type[0] == "bf2S02FXS" || $type[1] == "bf2S02FXS" || $type[0] == "bf1FXS" || $type[1] == "bf1FXS") {
                $form_elements.="<script>function country_setting(param)
			{
                            if (param!='USER'){
				$.ajax({
					url : 'modules/PstnHardware/ajax_country.php?country='+param,
                                        dataType: 'json',
					success : function (data) {
                                                $( 'select[name=\"ohs\"]' ).val(data['ohs']);
                                                $( 'select[name=\"rt\"]' ).val(data['rt']);
                                                $( 'select[name=\"rz\"]' ).val(data['rz']);
                                                $( 'select[name=\"dcv\"]' ).val(data['dcv']);
                                                $( 'select[name=\"mini\"]' ).val(data['mini']);
                                                $( 'select[name=\"acim\"]' ).val(data['acim']);
                                                $( 'select[name=\"ilim\"]' ).val(data['ilim']);
					}
				});
                             }
			}
                        function select_user(){
                            $( 'select[name=\"country\"]' ).val('USER');
                        }</script>";
                $form_elements.="<br/>"
			. "<br/>"
			. "<table class='table table-striped table-bordered' style='width:90% !important; margin:auto'>";
                if ($type[0] == "bf4FXO" || $type[1] == "bf4FXO" || $type[0] == "bf2FXO" || $type[1] == "bf2FXO") {
		if($database->get('gui_mode')=='simple') $simple_class='simple';
                    $form_elements.="<tr ><th><b>" . HARDWARE_COUNTRY_DIS . ":</b></th><th><select class='form-control' name='country' class='country' onchange=\"country_setting($(this).val());\" onmouseover=\"Tip('" . HARDWARE_COUNTRY . "')\" onmouseout='UnTip()'>";
                    foreach ($country as $value) {
                        if ($value == $database->get('country'))
                            $form_elements.="<option value='" . $value . "' selected>" . $value . "</option>";
                        else
                            $form_elements.="<option value='" . $value . "'>" . $value . "</option>";
                    }
                    $form_elements.="</select></th></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_OHS_DIS."</td><td>"
                            . "<select class='form-control' name='ohs' onchange='select_user();' class='country'>"
                            . "<option value='ohs=0|ohs2=0'>less than 0.5ms</option>";
                    ($database->get("ohs")==0 && $database->get("ohs2")==1) ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='ohs=0|ohs2=1' ".$selected.">3ms (ETSI)</option>";
                    ($database->get("ohs")==1 && $database->get("ohs2")==0) ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='ohs=1|ohs2=0' ".$selected.">26ms</option>"
                            . "</select>"
                            . "</td></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_RZ_DIS."</td><td>"
                            . "<select class='form-control' name='rz' onchange='select_user();' class='country'>"
                            . "<option value='0'>maximum ringer impedance</option>";
                    ($database->get("rz")==1) ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='1' ".$selected.">synthesized ringer impedance (poland, ZA, Slovenia)</option>"
                            . "</select>"
                            . "</td></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_RT_DIS."</td><td>"
                            . "<select class='form-control' name='rt' onchange='select_user();' class='country'>"
                            . "<option value='rt=0|rt2=0'>lower level: 13.5V upper level 16.5V</option>";
                    ($database->get("rt")==1 && $database->get("rt2")==0) ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='rt=1|rt2=0' ".$selected.">lower level: 19.35V upper level 23.65V</option>";
                    ($database->get("rt")==1 && $database->get("rt2")==1) ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='rt=1|rt2=1' ".$selected.">lower level: 40.5V upper level 49.5V</option>"
                            . "</select>"
                            . "</td></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_DCV_DIS."</td><td>"
                            . "<select class='form-control' name='dcv' onchange='select_user();' class='country'>"
                            . "<option value='0x0'>3.1V</option>";
                    ($database->get("dcv")=='0x1') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x1' ".$selected.">3.2V</option>";
                    ($database->get("dcv")=='0x2') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x2' ".$selected.">3.35V</option>";
                    ($database->get("dcv")=='0x3') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x3' ".$selected.">3.5V</option>"
                            . "</select>"
                            . "</td></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_MINI_DIS."</td><td>"
                            . "<select class='form-control' name='mini' onchange='select_user();' class='country'>"
                            . "<option value='0x0'>10 mA</option>";
                    ($database->get("mini")=='0x1') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x1' ".$selected.">12 mA</option>";
                    ($database->get("mini")=='0x2') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x2' ".$selected.">14 mA</option>";
                    ($database->get("mini")=='0x3') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x3' ".$selected.">16 mA</option>"
                            . "</select>"
                            . "</td></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_ILIM_DIS."</td><td>"
                            . "<select class='form-control' name='ilim' onchange='select_user();' class='country'>"
                            . "<option value='0'>no limit</option>";
                    ($database->get("ilim")=='1') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='1' ".$selected.">limit to 60mA</option>"
                            . "</select>"
                            . "</td></tr>";
                    $form_elements.="<tr class='$simple_class'><td>".HARDWARE_ACIM_DIS."</td><td>"
                            . "<select class='form-control' name='acim' onchange='select_user();' class='country'>"
                            . "<option value='0x0'>600 Ohm</option>";
                    ($database->get("acim")=='0x1') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x1' ".$selected.">900 Ohm</option>";
                    ($database->get("acim")=='0x2') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x2' ".$selected.">270 Ohm + (750 Ohm || 150nF) and 275 Ohm + (780 Ohm || 150nF)</option>";
                    ($database->get("acim")=='0x3') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x3' ".$selected.">220 Ohm + (820 Ohm || 120nF) and 220 Ohm + (820 Ohm || 115 nF)</option>";
                    ($database->get("acim")=='0x4') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x4' ".$selected.">370 Ohm + (620 Ohm || 310 nF)</option>";
                    ($database->get("acim")=='0x5') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x5' ".$selected.">320 Ohm + (1050 Ohm || 230 nF)</option>";
                    ($database->get("acim")=='0x6') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x6' ".$selected.">370 Ohm + (820 Ohm || 110 nF)</option>";
                    ($database->get("acim")=='0x7') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x7' ".$selected.">275 Ohm + (780 Ohm || 115 nF)</option>";
                    ($database->get("acim")=='0x8') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x8' ".$selected.">120 Ohm + (820 Ohm || 110 nF)</option>";
                    ($database->get("acim")=='0x9') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0x9' ".$selected.">350 Ohm + (1000 Ohm || 210 nF)</option>";
                    ($database->get("acim")=='0xa') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0xa' ".$selected.">200 Ohm + (680 Ohm || 100 nF)</option>";
                    ($database->get("acim")=='0xb') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0xb' ".$selected.">600 Ohm + 2.16 μF</option>";
                    ($database->get("acim")=='0xc') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0xc' ".$selected.">900 Ohm + 1 μF</option>";
                    ($database->get("acim")=='0xd') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0xd' ".$selected.">900 Ohm + 2.16 μF</option>";
                    ($database->get("acim")=='0xe') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0xe' ".$selected.">600 Ohm + 1 μF</option>";
                    ($database->get("acim")=='0xf') ? $selected="selected" : $selected="";
                    $form_elements.= "<option value='0xf' ".$selected.">Global impedance</option>"
                            . "</select>"
                            . "</td></tr>";
                }
                if ($type[0] == "bf4FXS" || $type[1] == "bf4FXS" || $type[0] == "bf8FXS" || $type[1] == "bf8FXS" || $type[0] == "bf2S02FXS" || $type[1] == "bf2S02FXS" || $type[0] == "bf1FXS" || $type[1] == "bf1FXS") {
                    $form_elements.="<tr ><th><b>" . HARDWARE_BOOSTRINGER_DIS . ":</b></th><th><select class='form-control' name='boostringer'>";

                    ($database->get('boostringer') == 0) ? $form_elements.="<option value='0' selected>49V</option>" : $form_elements.="<option value='0'>49V</option>";
                    ($database->get('boostringer') == 1) ? $form_elements.="<option value='1' selected>89V</option>" : $form_elements.="<option value='1'>89V</option>";
                    $form_elements.="</select></th></tr>";
                }
                $form_elements.="</table>";
            }

            //Portswitch
            if (($type[0] == "bf4S0" || $type[0] == "bf4FXO" || $type[0] == "bf4FXS" || $type[0] == "bf2S02FXS") && !isset($type[1]) && $revision != "1.80" && $revision != "1.8") {
                $form_elements.="<br/>"
			. "<br/>"
			. "<table class='table table-striped table-bordered' style='width:90% !important; margin:auto;'>"
			. "<tr onmouseover=\"Tip('" . HARDWARE_PORT_SWITCH . "')\" onmouseout='UnTip()'>
								<th>" . HARDWARE_CARD_TYPE_DIS . ":&nbsp;none&nbsp;&nbsp;" . HARDWARE_LINE_INTERFACE_DIS . ":&nbsp;1&nbsp;&nbsp;" . HARDWARE_PORTSWITCH_DIS . ":&nbsp;";
                //$query=$database->select("select value from key_val where key='portswitch'");
                if ($database->get('portswitch') == "") {
                    $form_elements.="<input type='checkbox' name='portswitch' value='1' checked>";
                } elseif ($database->get('portswitch') == "1") {
                    $form_elements.="<input type='checkbox' name='portswitch' value='1' checked>";
                } elseif ($database->get('portswitch') == "0") {
                    $form_elements.="<input type='checkbox' name='portswitch' value='1'>";
                }
                $form_elements.="</th>"
			. "</tr>"
			. "</table>";
            }
            $form_elements.="<br /><br />";
            //PCM
            $pcm_ip = "";
            if ($database->get('pcm_server') != 0 && $database->get('pcm_server') != 1)
                $pcm_ip = $database->get('pcm_server');
            $pcm_server_port = '54329';
            if ($database->get('pcm_server_port') != "")
                $pcm_server_port = $database->get('pcm_server_port');
            $form_elements.="<table id='pcm_client' style='width:90% !important; display:none; margin:auto;' class='table table-striped table-bordered'>
		                     <tr>
		                         <th nowrap>
						<div class='row'>
		                         	<div class='col-sm-5'>" . HARDWARE_PCM_MASTER_IP_DIS . ":</div>
		                         	<div class='col-sm-7'><input type='text' class='form-control' name='pcm_ip' value='" . $pcm_ip . "'></div>
						</div>
		                         </th>
		                         <th nowrap>
						<div class='row'>
		                         	<div class='col-sm-5'>" . HARDWARE_PCM_MASTER_PORT_DIS . ":</div>

		                         	<div class='col-sm-7'><input type='text' class='form-control' name='pcm_server_port' value='" . $pcm_server_port . "'></div>
						</div>	
		                         </th>
		                     </tr>
		                 </table>";

            $form_elements.="<table id='pcm_server' style='width:90% !important; margin:auto; display:none;' class='table table-striped table-bordered'>
		                     <tr>
		                         <th nowrap onmouseover=\"Tip('" . HARDWARE_PCM_BRIDGING . "')\" onmouseout='UnTip()'>
		                         	<div class='row'>
						<div class='col-sm-5'>" . HARDWARE_PCM_BRIDGING_DIS . ":</div>"
		    . "<div class='col-sm-7'>";
            if ($database->get('pcm_server') == 1)
                $form_elements.="<input type='checkbox' name='pcm_server' value='1' checked>";
            else
                $form_elements.="<input type='checkbox' name='pcm_server' value='1'>";
            $form_elements.="</div>
		    </div>
		    </th>
		                         <th nowrap>
						<div class='row'>
		                         	<div class='col-sm-4'>" . HARDWARE_PCM_MASTER_PORT_DIS . ":</div>
		                         	<div class='col-sm-8'>
						<input type='text' class='form-control' name='pcm_server_port' value='" . $pcm_server_port . "'>
						</div>
						</div>
		                         </th>
		                     </tr>
		                 </table>";

            $form_elements.="<br/>
		<div class='text-center'><input type='submit' class='btn btn-default' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . ISDNHW_SAVE . "')\"
		onmouseout='UnTip()'></div><script>
                function check_master(){
			try{
				if (document.getElementsByName('master_li0')[0].selectedIndex==1 && document.getElementsByName('master_li1')[0].selectedIndex==1){
					document.getElementById('pcm_client').style.display='';
				}else{
					document.getElementById('pcm_client').style.display='none';
				}
			}catch(e){

			}

			try{
				if ((document.getElementsByName('master_li0')[0].selectedIndex==1 && document.getElementsByName('master_li1')[0].selectedIndex==0) || (document.getElementsByName('master_li0')[0].selectedIndex==0 && document.getElementsByName('master_li1')[0].selectedIndex==1)){
					document.getElementById('pcm_server').style.display='';
					document.getElementsByName('pcm_server')[0].disabled=false;
				}else{
					document.getElementById('pcm_server').style.display='none';
					document.getElementsByName('pcm_server')[0].disabled=true;
				}
			}catch(e){

			}

			try{
				if (document.getElementsByName('master_li0')[0].selectedIndex==0){
					document.isdn_hw.sync_li0.disabled=false;
					document.getElementById('sync_port_li0').style.display='';
                                        $('.crystal_clock0').prop('disabled',false);
				}else{
					document.isdn_hw.sync_li0.disabled=true;
					document.getElementById('sync_port_li0').style.display='none';
                                        $('.crystal_clock0').prop('selectedIndex',1);
                                        $('.crystal_clock0').prop('disabled',true);
				}
			}catch(e){

			}

			try{
				if (document.getElementsByName('master_li1')[0].selectedIndex==0){
					document.isdn_hw.sync_li1.disabled=false;
					document.getElementById('sync_port_li1').style.display='';
                                        $('.crystal_clock1').prop('disabled',false);
				}else{
					document.isdn_hw.sync_li1.disabled=true;
					document.getElementById('sync_port_li1').style.display='none';
                                        $('.crystal_clock1').prop('selectedIndex',1);
                                        $('.crystal_clock1').prop('disabled',true);
				}
			}catch(e){

			}";
            //Wenn kein LI steckt, kann nur client sein
            if ($li[0] == "" && $li[1] == "")
                $form_elements.= "try{
					document.getElementById('pcm_server').style.display='none';
					document.getElementById('pcm_client').style.display='';
			}catch(e){

			}";
            if ($li[0] == "0" && $li[1] == "")
                $form_elements.= "try{
				if (document.getElementsByName('master_li0')[0].selectedIndex==1){
					document.getElementById('pcm_client').style.display='';
				}else{
					document.getElementById('pcm_client').style.display='none';
				}
			}catch(e){

			}
			try{
				if (document.getElementsByName('master_li0')[0].selectedIndex==0){
					document.getElementById('pcm_server').style.display='';
				}else{
					document.getElementById('pcm_server').style.display='none';
				}
			}catch(e){

			}";
            if ($li[0] == "1" && $li[1] == "")
                $form_elements.= "try{
				if (document.getElementsByName('master_li1')[0].selectedIndex==1){
					document.getElementById('pcm_client').style.display='';
				}else{
					document.getElementById('pcm_client').style.display='none';
				}
			}catch(e){

			}
			try{
				if (document.getElementsByName('master_li1')[0].selectedIndex==0){
					document.getElementById('pcm_server').style.display='';
				}else{
					document.getElementById('pcm_server').style.display='none';
				}
			}catch(e){

			}";
            if ($type[0] == "bf2GSM" || $type[1] == "bf2GSM" || $type[0] == "bf1GSM" || $type[1] == "bf1GSM")
                $form_elements.= "try{
					document.getElementById('pcm_client').style.display='none';
			}catch(e){

			}
			try{
					document.getElementById('pcm_server').style.display='none';
			}catch(e){

			}";
            //Die funktion check_master wird erst hier geschlossen
            $form_elements.="}
		check_master();
		</script>";
        }
        return $form_elements;
    }

}

?>
